searchNodes=[{"doc":"Operations on the AWS DynamoDB service. NOTE: When Mix.env in [:test, :dev], Dynamo clients will run by default against DynamoDB local. Basic usage defmodule User do @derive [ ExAws.Dynamo.Encodable ] defstruct [ :email , :name , :age , :admin ] end alias ExAws.Dynamo # Create a provisioned users table with a primary key of email [String] # and 1 unit of read and write capacity Dynamo . create_table ( &quot;Users&quot; , &quot;email&quot; , %{ email : :string } , 1 , 1 ) |&gt; ExAws . request! user = % User { email : &quot;bubba@foo.com&quot; , name : &quot;Bubba&quot; , age : 23 , admin : false } # Save the user Dynamo . put_item ( &quot;Users&quot; , user ) |&gt; ExAws . request! # Retrieve the user by email and decode it as a User struct. result = Dynamo . get_item ( &quot;Users&quot; , %{ email : user . email } ) |&gt; ExAws . request! |&gt; Dynamo . decode_item ( as : User ) assert user == result General notes All options are handled as underscored atoms instead of camelcased binaries as specified in the Dynamo API, e.g. IndexName would be :index_name . Anywhere in the API that requires Dynamo type annotation ( {&quot;S&quot;:&quot;mystring&quot;} ) is handled for you automatically. For example, ExAws.Dynamo . scan ( &quot;Users&quot; , expression_attribute_values : [ api_key : &quot;foo&quot; ] ) transforms into a query of %{ &quot;ExpressionAttributeValues&quot; =&gt; %{ api_key : %{ &quot;S&quot; =&gt; &quot;foo&quot; } } , &quot;TableName&quot; =&gt; &quot;Users&quot; } Consult the function documentation to see precisely which options are handled this way. If you wish to avoid this kind of automatic behaviour, you are free to specify the types yourself. For example, ExAws.Dynamo . scan ( &quot;Users&quot; , expression_attribute_values : [ api_key : %{ &quot;B&quot; =&gt; &quot;Treated as binary&quot; } ] ) becomes %{ &quot;ExpressionAttributeValues&quot; =&gt; %{ api_key : %{ &quot;B&quot; =&gt; &quot;Treated as binary&quot; } } , &quot;TableName&quot; =&gt; &quot;Users&quot; } Alternatively, if what's being encoded is a struct, you're always free to implement ExAws.Dynamo.Encodable for that struct. https://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_Operations.html","ref":"ExAws.Dynamo.html","title":"ExAws.Dynamo","type":"module"},{"doc":"Batch-get up to 100 items (16 MB total max) Map of table names to request parameter maps. https://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_BatchGetItem.html Parameters with keys that are automatically annotated with dynamo types are: [:keys] Dynamo . batch_get_item ( %{ &quot;Users&quot; =&gt; [ consistent_read : true , keys : [ [ api_key : &quot;key1&quot; ] , [ api_key : &quot;api_key2&quot; ] ] , expression_attribute_names : %{ &quot;#api_key&quot; =&gt; &quot;api_key&quot; } , projection_expression : &quot;#api_key&quot; ] , &quot;Subscriptions&quot; =&gt; %{ keys : [ %{ id : &quot;id1&quot; } ] } } ) As you see, you're largely free to use either keyword args or maps in the body. A map is required for the argument itself because the table names are most often binaries, and I refuse to inflict proplists on anyone.","ref":"ExAws.Dynamo.html#batch_get_item/2","title":"ExAws.Dynamo.batch_get_item/2","type":"function"},{"doc":"Put or delete up to 25 items (16 MB total max) Map of table names to request parameter maps. https://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_BatchWriteItem.html Parameters with keys that are automatically annotated with Dynamo types are: [:keys]","ref":"ExAws.Dynamo.html#batch_write_item/2","title":"ExAws.Dynamo.batch_write_item/2","type":"function"},{"doc":"Create table with arbitrary options. This provides a superset of the functionality of other create_table variants, allowing the specification of any options as per the create_table_opts/0 type. If no options are specified, defaults will be used as follows: billing_mode : :provisioned read_capacity : 10 write_capacity : 10 stream_enabled : false","ref":"ExAws.Dynamo.html#create_table/4","title":"ExAws.Dynamo.create_table/4","type":"function"},{"doc":"Create table key_schema can be a simple binary or atom indicating a simple hash key. billing_mode may be either :provisioned (default) or :pay_per_request . If you are creating a :pay-per-request table, you will still need to provide values for read and write capacities, although they will be ignored - you may consider providing nil in those cases.","ref":"ExAws.Dynamo.html#create_table/6","title":"ExAws.Dynamo.create_table/6","type":"function"},{"doc":"Create table with secondary indices Each index should follow the format outlined here: https://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_CreateTable.html For convenience, the keys in each index map are allowed to be atoms. e.g: &quot;KeySchema&quot; in the aws docs can be key_schema: Note that both the global_indexes and local_indexes arguments expect a list of such indices. billing_mode may be either :provisioned (default) or :pay_per_request . If you are creating a :pay-per-request table, you will still need to provide values for read and write capacities, although they will be ignored - you may consider providing nil in those cases. Examples secondary_index = [ %{ index_name : &quot;my-global-index&quot; , key_schema : [ %{ attribute_name : &quot;email&quot; , key_type : &quot;HASH&quot; , } ] , provisioned_throughput : %{ read_capacity_units : 1 , write_capacity_units : 1 , } , projection : %{ projection_type : &quot;KEYS_ONLY&quot; , } } ] create_table ( &quot;TestUsers&quot; , [ id : :hash ] , %{ id : :string , email : :string } , 1 , 1 , secondary_index , [ ] )","ref":"ExAws.Dynamo.html#create_table/8","title":"ExAws.Dynamo.create_table/8","type":"function"},{"doc":"Decode an item returned from Dynamo. This will handle items wrapped in the ordinary get_item response map of %{&quot;Item&quot; =&gt; item} . Example Dynamo . get_item ( &quot;users&quot; , %{ id : &quot;asdf&quot; } ) |&gt; ExAws . request! |&gt; Dynamo . decode_item ( as : User )","ref":"ExAws.Dynamo.html#decode_item/2","title":"ExAws.Dynamo.decode_item/2","type":"function"},{"doc":"Delete item in table","ref":"ExAws.Dynamo.html#delete_item/3","title":"ExAws.Dynamo.delete_item/3","type":"function"},{"doc":"Delete Table","ref":"ExAws.Dynamo.html#delete_table/1","title":"ExAws.Dynamo.delete_table/1","type":"function"},{"doc":"Describe table","ref":"ExAws.Dynamo.html#describe_table/1","title":"ExAws.Dynamo.describe_table/1","type":"function"},{"doc":"Describe time to live","ref":"ExAws.Dynamo.html#describe_time_to_live/1","title":"ExAws.Dynamo.describe_time_to_live/1","type":"function"},{"doc":"Get item from table","ref":"ExAws.Dynamo.html#get_item/3","title":"ExAws.Dynamo.get_item/3","type":"function"},{"doc":"List tables","ref":"ExAws.Dynamo.html#list_tables/0","title":"ExAws.Dynamo.list_tables/0","type":"function"},{"doc":"Put item in table","ref":"ExAws.Dynamo.html#put_item/3","title":"ExAws.Dynamo.put_item/3","type":"function"},{"doc":"Query Table Please read https://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_Query.html Dynamo . query ( &quot;Users&quot; , limit : 1 , expression_attribute_values : [ desired_api_key : &quot;adminkey&quot; ] , key_condition_expression : &quot;api_key = :desired_api_key&quot; ) Parameters with keys that are automatically annotated with dynamo types are: [:exclusive_start_key, :expression_attribute_names]","ref":"ExAws.Dynamo.html#query/2","title":"ExAws.Dynamo.query/2","type":"function"},{"doc":"Scan table Please read https://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_Scan.html Dynamo . scan ( &quot;Users&quot; limit : 1 , expression_attribute_values : [ desired_api_key : &quot;adminkey&quot; ] , expression_attribute_names : %{ &quot;#asdf&quot; =&gt; &quot;api_key&quot; } , filter_expression : &quot;#asdf = :desired_api_key&quot; ) Generally speaking, you won't need to use :expression_attribute_names . It exists to alias a column name if one of the columns you want to search against is a reserved Dynamo word, like Percentile . In this case, it's totally unnecessary as api_key is not a reserved word. Parameters with keys that are automatically annotated with Dynamo types are: [:exclusive_start_key, :expression_attribute_names]","ref":"ExAws.Dynamo.html#scan/2","title":"ExAws.Dynamo.scan/2","type":"function"},{"doc":"A synchronous operation that retrieves multiple items from one or more tables (but not from indexes) in a single account and region","ref":"ExAws.Dynamo.html#transact_get_items/2","title":"ExAws.Dynamo.transact_get_items/2","type":"function"},{"doc":"A synchronous write operation that groups up to 25 action requests","ref":"ExAws.Dynamo.html#transact_write_items/2","title":"ExAws.Dynamo.transact_write_items/2","type":"function"},{"doc":"Update item in table For update_args format see https://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_UpdateItem.html","ref":"ExAws.Dynamo.html#update_item/3","title":"ExAws.Dynamo.update_item/3","type":"function"},{"doc":"Update Table","ref":"ExAws.Dynamo.html#update_table/2","title":"ExAws.Dynamo.update_table/2","type":"function"},{"doc":"Update time to live","ref":"ExAws.Dynamo.html#update_time_to_live/3","title":"ExAws.Dynamo.update_time_to_live/3","type":"function"},{"doc":"","ref":"ExAws.Dynamo.html#t:batch_get_item_opts/0","title":"ExAws.Dynamo.batch_get_item_opts/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:batch_write_item_opts/0","title":"ExAws.Dynamo.batch_write_item_opts/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:create_table_opts/0","title":"ExAws.Dynamo.create_table_opts/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:delete_item_opts/0","title":"ExAws.Dynamo.delete_item_opts/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:dynamo_billing_types/0","title":"ExAws.Dynamo.dynamo_billing_types/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:dynamo_type_names/0","title":"ExAws.Dynamo.dynamo_type_names/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:exclusive_start_key_vals/0","title":"ExAws.Dynamo.exclusive_start_key_vals/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:expression_attribute_names_vals/0","title":"ExAws.Dynamo.expression_attribute_names_vals/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:expression_attribute_values_vals/0","title":"ExAws.Dynamo.expression_attribute_values_vals/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:get_item/0","title":"ExAws.Dynamo.get_item/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:get_item_opts/0","title":"ExAws.Dynamo.get_item_opts/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:key_definitions/0","title":"ExAws.Dynamo.key_definitions/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:key_schema/0","title":"ExAws.Dynamo.key_schema/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:primary_key/0","title":"ExAws.Dynamo.primary_key/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:put_item_opts/0","title":"ExAws.Dynamo.put_item_opts/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:query_opts/0","title":"ExAws.Dynamo.query_opts/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:return_consumed_capacity_vals/0","title":"ExAws.Dynamo.return_consumed_capacity_vals/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:return_item_collection_metrics_vals/0","title":"ExAws.Dynamo.return_item_collection_metrics_vals/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:return_values_on_condition_check_failure_vals/0","title":"ExAws.Dynamo.return_values_on_condition_check_failure_vals/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:return_values_vals/0","title":"ExAws.Dynamo.return_values_vals/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:scan_opts/0","title":"ExAws.Dynamo.scan_opts/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:select_vals/0","title":"ExAws.Dynamo.select_vals/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:stream_view_type/0","title":"ExAws.Dynamo.stream_view_type/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:table_name/0","title":"ExAws.Dynamo.table_name/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:transact_get_item/0","title":"ExAws.Dynamo.transact_get_item/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:transact_get_item_opts/0","title":"ExAws.Dynamo.transact_get_item_opts/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:transact_get_items_opts/0","title":"ExAws.Dynamo.transact_get_items_opts/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:transact_standard_item_opts/0","title":"ExAws.Dynamo.transact_standard_item_opts/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:transact_update_item_opts/0","title":"ExAws.Dynamo.transact_update_item_opts/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:transact_write_item/0","title":"ExAws.Dynamo.transact_write_item/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:transact_write_items_opts/0","title":"ExAws.Dynamo.transact_write_items_opts/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:update_item_opts/0","title":"ExAws.Dynamo.update_item_opts/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:update_table_opts/0","title":"ExAws.Dynamo.update_table_opts/0","type":"type"},{"doc":"","ref":"ExAws.Dynamo.html#t:write_item/0","title":"ExAws.Dynamo.write_item/0","type":"type"},{"doc":"Allows custom decoding logic for your struct.","ref":"ExAws.Dynamo.Decodable.html","title":"ExAws.Dynamo.Decodable","type":"protocol"},{"doc":"","ref":"ExAws.Dynamo.Decodable.html#decode/1","title":"ExAws.Dynamo.Decodable.decode/1","type":"function"},{"doc":"","ref":"ExAws.Dynamo.Decodable.html#t:t/0","title":"ExAws.Dynamo.Decodable.t/0","type":"type"},{"doc":"Decodes a Dynamo response into a struct. If Dynamo.Decodable is implemented for the struct, it will be called after the completion of the coercion. This is important for handling nested maps if you wanted the nested maps to have atom keys.","ref":"ExAws.Dynamo.Decoder.html","title":"ExAws.Dynamo.Decoder","type":"module"},{"doc":"Converts a map with binary keys to the specified struct","ref":"ExAws.Dynamo.Decoder.html#binary_map_to_struct/2","title":"ExAws.Dynamo.Decoder.binary_map_to_struct/2","type":"function"},{"doc":"Attempts to convert a number to a float, and then an integer","ref":"ExAws.Dynamo.Decoder.html#binary_to_number/1","title":"ExAws.Dynamo.Decoder.binary_to_number/1","type":"function"},{"doc":"Convert Dynamo format to Elixir Functions which convert the Dynamo-style values into normal Elixir values. Use these if you just want the Dynamo result to look more like Elixir without coercing it into a particular struct.","ref":"ExAws.Dynamo.Decoder.html#decode/1","title":"ExAws.Dynamo.Decoder.decode/1","type":"function"},{"doc":"","ref":"ExAws.Dynamo.Decoder.html#decode/2","title":"ExAws.Dynamo.Decoder.decode/2","type":"function"},{"doc":"","ref":"ExAws.Dynamo.Encodable.html","title":"ExAws.Dynamo.Encodable","type":"protocol"},{"doc":"Converts an Elixir value into a map tagging the value with its Dynamo type","ref":"ExAws.Dynamo.Encodable.html#encode/2","title":"ExAws.Dynamo.Encodable.encode/2","type":"function"},{"doc":"","ref":"ExAws.Dynamo.Encodable.html#t:t/0","title":"ExAws.Dynamo.Encodable.t/0","type":"type"},{"doc":"Takes an Elixir value and converts it into a Dynamo-style map. MapSet . new [ 1 , 2 , 3 ] |&gt; Elixir.ExAws.Dynamo.Encoder . encode #=&gt; %{&quot;NS&quot; =&gt; [&quot;1&quot;, &quot;2&quot;, &quot;3&quot;]} MapSet . new [ &quot;A&quot; , &quot;B&quot; , &quot;C&quot; ] |&gt; Elixir.ExAws.Dynamo.Encoder . encode #=&gt; %{&quot;SS&quot; =&gt; [&quot;A&quot;, &quot;B&quot;, &quot;C&quot;]} &quot;bubba&quot; |&gt; ExAws.Dynamo.Encoder . encode #=&gt; %{&quot;S&quot; =&gt; &quot;bubba&quot;} This is handled via the ExAws.Dynamo.Encodable protocol.","ref":"ExAws.Dynamo.Encoder.html","title":"ExAws.Dynamo.Encoder","type":"module"},{"doc":"","ref":"ExAws.Dynamo.Encoder.html#atom_to_dynamo_type/1","title":"ExAws.Dynamo.Encoder.atom_to_dynamo_type/1","type":"function"},{"doc":"","ref":"ExAws.Dynamo.Encoder.html#encode/1","title":"ExAws.Dynamo.Encoder.encode/1","type":"function"},{"doc":"","ref":"ExAws.Dynamo.Encoder.html#encode/2","title":"ExAws.Dynamo.Encoder.encode/2","type":"function"},{"doc":"","ref":"ExAws.Dynamo.Encoder.html#encode!/2","title":"ExAws.Dynamo.Encoder.encode!/2","type":"function"},{"doc":"","ref":"ExAws.Dynamo.Encoder.html#encode_root/2","title":"ExAws.Dynamo.Encoder.encode_root/2","type":"function"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Fixes spec","ref":"changelog.html#v4-2-1-2023-02-12","title":"Changelog - v4.2.1 - 2023-02-12","type":"extras"},{"doc":"Add info on transaction failures Increase minimum ex_aws version to 2.4.0 Fix encoding of boolean attributes","ref":"changelog.html#v4-2-0-2022-09-12","title":"Changelog - v4.2.0 - 2022-09-12","type":"extras"},{"doc":"Add :stream_enabled and :stream_view_type options to table creation and updates Increase minimum Elixir version to 1.10","ref":"changelog.html#v4-1-0-2022-03-23","title":"Changelog - v4.1.0 - 2022-03-23","type":"extras"},{"doc":"Add :consistent_read option in scan_opts spec Add code_quality alias Adds dialyxir to dev dependencies Various credo and dialyzer fixes Fixes typos in documentation and README","ref":"changelog.html#v4-0-2-2021-12-24","title":"Changelog - v4.0.2 - 2021-12-24","type":"extras"},{"doc":"Update dependencies Update documentation","ref":"changelog.html#v4-0-1-2021-04-26","title":"Changelog - v4.0.1 - 2021-04-26","type":"extras"},{"doc":"Add support for empty string/binary attributes Empty string is saved as a space when using put_item","ref":"changelog.html#v4-0-0-2020-07-06","title":"Changelog - v4.0.0 - 2020-07-06","type":"extras"},{"doc":"Update dependencies","ref":"changelog.html#v3-0-3-2020-07-03","title":"Changelog - v3.0.3 - 2020-07-03","type":"extras"},{"doc":"Add empty prod.exs config file","ref":"changelog.html#v3-0-2-2020-05-23","title":"Changelog - v3.0.2 - 2020-05-23","type":"extras"},{"doc":"Upcase return_consumed_capacity values on batch calls Documentation updates and fixes","ref":"changelog.html#v3-0-1-2020-05-04","title":"Changelog - v3.0.1 - 2020-05-04","type":"extras"},{"doc":"Set minimum version of ex_aws to 2.1.2 Remove reference to :decode_sets_config option","ref":"changelog.html#v3-0-0-2020-02-22","title":"Changelog - v3.0.0 - 2020-02-22","type":"extras"},{"doc":"Additional documentation changes Set config/test.exs as a 'bare-bones' config file Import ddb_local_test.exs only if it has been provided.","ref":"changelog.html#v2-3-4-2019-10-31","title":"Changelog - v2.3.4 - 2019-10-31","type":"extras"},{"doc":"Allow expression_attribute_names to be specified in batch_get_item Add badges to documentation","ref":"changelog.html#v2-3-3-2019-10-24","title":"Changelog - v2.3.3 - 2019-10-24","type":"extras"},{"doc":"Set :debug_requests to false in test.exs.example Run integration tests only local DDB instance found","ref":"changelog.html#v2-3-2-2019-10-20","title":"Changelog - v2.3.2 - 2019-10-20","type":"extras"},{"doc":"Fix documentation","ref":"changelog.html#v2-3-1-2019-10-07","title":"Changelog - v2.3.1 - 2019-10-07","type":"extras"},{"doc":"Add DynamoDb transaction API calls Code formatting","ref":"changelog.html#v2-3-0-2019-09-27","title":"Changelog - v2.3.0 - 2019-09-27","type":"extras"},{"doc":"Add instructions on running integration tests against local DDB","ref":"changelog.html#v2-2-2-2019-09-25","title":"Changelog - v2.2.2 - 2019-09-25","type":"extras"},{"doc":"Properly handle Binary fields","ref":"changelog.html#v2-2-1-2019-08-27","title":"Changelog - v2.2.1 - 2019-08-27","type":"extras"},{"doc":"Fix type expression_attribute_values_vals Decode sets as MapSet","ref":"changelog.html#v2-2-0-2019-08-12","title":"Changelog - v2.2.0 - 2019-08-12","type":"extras"},{"doc":"Add support for billing mode Add ability to specify billing mode and TTL during table create and update Add support for list of items while decoding Add Dynamo.update_time_to_live and Dynamo.describe_time_to_live","ref":"changelog.html#v2-1-0-2019-07-19","title":"Changelog - v2.1.0 - 2019-07-19","type":"extras"},{"doc":"Major Project Split. Please see the main ExAws repository for previous changelogs .","ref":"changelog.html#v2-0-0-2017-11-10","title":"Changelog - v2.0.0 - 2017-11-10","type":"extras"},{"doc":"Service module for https://github.com/ex-aws/ex_aws","ref":"readme.html","title":"ExAws.Dynamo","type":"extras"},{"doc":"The package can be installed by adding :ex_aws_dynamo to your list of dependencies in mix.exs along with your preferred JSON codec and HTTP client: def deps do [ { :ex_aws_dynamo , &quot;~&gt; 4.0&quot; } , { :jason , &quot;~&gt; 1.0&quot; } , { :hackney , &quot;~&gt; 1.9&quot; } ] end ExAws uses Jason as its default JSON codec - if you intend to use a different codec, see ex_aws for more information about setting a custom :json_codec . Documentation for ExAwsDynamo can be found at https://hexdocs.pm/ex_aws_dynamo .","ref":"readme.html#installation","title":"ExAws.Dynamo - Installation","type":"extras"},{"doc":"DynamoDB Local If you are running this module against a local development instance of DynamoDB, you'll want to make sure that you have installed the latest version, 1.17.2 (released 2021-12-16). You can find links to download the latest version here .","ref":"readme.html#requirements","title":"ExAws.Dynamo - Requirements","type":"extras"},{"doc":"ExAws In order to use ExAws.Dynamo against a production instance of DynamoDB, your app will need to provide the following configuration for :ex_aws : Example configuration: config :ex_aws , access_key_id : [ { :system , &quot;AWS_ACCESS_KEY_ID&quot; } , :instance_role ] , secret_access_key : [ { :system , &quot;AWS_SECRET_ACCESS_KEY&quot; } , :instance_role ] :access_key_id :: string The ID portion of a set of AWS credentials. :secret_access_key :: string The secret portion of a set of AWS credentials. Please see the ExAws README for additional reference.","ref":"readme.html#configuration","title":"ExAws.Dynamo - Configuration","type":"extras"},{"doc":"Integration tests (optional) The tests in test/lib/dynamo/integration_test.exs will attempt to run against a local instance of DynamoDB - in order to run these tests, you will need both a running local instance of DynamoDB as well as a config/ddb_local_test.exs file (.gitignored) formatted like so: config/ddb_local_test.exs import Config config :ex_aws , debug_requests : false , # set to true to monitor the DDB requests access_key_id : &quot;abcd&quot; , secret_access_key : &quot;1234&quot; , region : &quot;us-east-1&quot; config :ex_aws , :dynamodb , scheme : &quot;http://&quot; , host : &quot;localhost&quot; , port : SET_YOUR_PORT , region : &quot;us-east-1&quot; (or see config/ddb_local_test.exs.example ) Before running tests, be aware that test/lib/dynamo/integration_test.exs will create and delete tables with the names &quot;TestUsers&quot; , &quot;Test.User&quot; , &quot;TestSeveralUsers&quot; , &quot;TestFoo&quot; , &quot;test_books&quot; , &quot;TestUsersWithRange&quot; , &quot;TestTransactions&quot; , &quot;TestTransactions2&quot; - test operations may affect your current tables if they share any of those names. You may consider maintaining a separate instance of DynamoDB local (or at least a separate instance of its shared-local-instance.db file) for testing. If DynamoDB is not running locally or the config file has not been provided, the integration tests will be skipped.","ref":"readme.html#testing","title":"ExAws.Dynamo - Testing","type":"extras"},{"doc":"The MIT License (MIT) Copyright (c) 2014 CargoSense, Inc. Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"readme.html#copyright-and-license","title":"ExAws.Dynamo - Copyright and License","type":"extras"},{"doc":"","ref":"upgrade.html","title":"Upgrading","type":"extras"},{"doc":"Empty string/binary values allowed In May, 2020, DynamoDB was updated to allow storage of empty strings and binaries in non-key fields - documentation . In earlier versions of this app, fields with empty string attributes were stripped off prior to writing to the DB by ExAws.Dynamo.Encodable.do_encode/1 ; however, in light of these developments, the default behavior of this app will now be to write empty string values. Please check your application thoroughly and make sure you are prepared for dealing with the possibility of having empty strings in fields that may previously have been expected to return nil (since, in the past, they wouldn't have been written at all). To be clear, existing data is not going to be changed - but if, prior to upgrading to version 4, you wrote a record with the values %{id: &quot;1&quot;, optional_string: &quot;&quot;} , that record will still be returned as %{id: 1, optional_string: nil} ; if you write a record after upgrading, say %{id: &quot;2&quot;, optional_string: &quot;&quot;} , that record will be returned exactly as written, %{id: &quot;2&quot;, optional_string: &quot;&quot;} .","ref":"upgrade.html#3-x-x-to-4-x-x","title":"Upgrading - 3.X.X to 4.X.X","type":"extras"},{"doc":"MapSet Prior to version 2.2.0 , ex_aws_dynamo was encoding MapSet data into one of the three Dynamo set types (number, string, and binary), but was decoding those types into Elixir List data. In version 2.2.0 , a PR added a boolean configuration option, :decode_sets , that would allow the user to specify that these types should be decoded into MapSet as well. In this major release, Dynamo set types decode to Elixir MapSet by default, so the :decode_sets configuration option can be removed if it was included. If it this option was not included or was explicitly set to false , you'll need to be prepared to handle any decoded Dynamo sets as MapSet instead of List . Jason Several months ago, ex_aws switched its default JSON codec from Poison to Jason (see https://github.com/ex-aws/ex_aws/pull/658 ). In this major release, the encoder used for dev and test environments has been changed to Jason , and the README file has been updated to show Jason in use instead of Poison , and refers the user to the ex_aws docs for information about how to provide a custom JSON codec.","ref":"upgrade.html#2-x-x-to-3-x-x","title":"Upgrading - 2.X.X to 3.X.X","type":"extras"}]